<?php
namespace App\Filament\Pages;

use App\Filament\Widgets\CumulativeChart;
use App\Filament\Widgets\ProductionQuantityStat;
use Filament\Forms\Components\Select;
use Filament\Forms\Components\TextInput;
use Filament\Forms\Form;
use Filament\Pages\Dashboard\Concerns\HasFiltersForm;
use Filament\Tables\Filters\SelectFilter;
use Illuminate\Support\Facades\DB;
use App\Models\Plant;
use Filament\Facades\Filament;
use Filament\Widgets\Widget;
use Illuminate\Support\Facades\Auth;

class Dashboard extends \Filament\Pages\Dashboard
{
   use HasFiltersForm;

   protected static ?string $navigationGroup = 'Production DashBoard';

   public function mount(): void
   {
       session()->forget(['selected_plant']);
       $this->filtersForm->fill([
           'plant' => null,
           'success_status' => null
       ]);
   }

    public function filtersForm(Form $form): Form
    {
       return $form
           ->statePath('filters') // Store form state in 'filters'
           ->schema([
               Select::make('plant')
                    ->label('Select Plant')
                    ->reactive()
                    // ->options(Plant::pluck('name', 'id'))
                    ->options(function (callable $get) {
                        $userHas = Filament::auth()->user()->plant_id;
                        return ($userHas && strlen($userHas) > 0) ? Plant::where('id', $userHas)->pluck('name', 'id')->toArray() : Plant::pluck('name', 'id')->toArray();
                    })
                    ->afterStateUpdated(function ($state,callable $set) {
                        session(['selected_plant' => $state]); // fixed typo
                        //$this->dispatch('cumulativeChart'); // custom Livewire event
                            // Reset success_status whenever plant changes
                            $set('success_status', null);
                            session()->forget('success_status');
                    }),

                 Select::make('success_status')
                    ->label('Select Status')
                    ->options([
                            'Ok'     => 'Ok',
                            'Not Ok' => 'Not Ok',
                        ])
                    ->reactive()
                    ->afterStateUpdated(function ($state) {
                        session(['success_status' => $state]);
                    }),
                ]);
    }


    public static function getNavigationLabel(): string
    {
        return 'Production Line Count';
    }

    public function getHeading(): string
    {
        return 'Production Line Count';
    }

    public function getWidgets(): array
    {
        $widgets = [];

        if (CumulativeChart::canView()) {
           $widgets[] = CumulativeChart::class;

        }
        return $widgets;
    }



    public static function canAccess(): bool
    {
        return Auth::check() && Auth::user()->can('view production line count dashboard');
    }

}
